# Release Notes v0.16.1 : Automated GUI Testing

This release automates GUI testing with Qt Test and CI on GNU/Linux, macOS, and Windows.


## Minor Changes

- GUI: Automated GUI Testing (#202)
- GUI: Present interface languages in sorted order (#242)
- GUI: Doxygen code doc generation and coverage (#243)
- GUI: Spanish translation (thanks to @NeHoMaR)
- GUI: Turkish translation (thanks to [irfandogan](https://crowdin.com/profile/irfandogan))
- GUI: Dutch translation (thanks to [Omer Surer](https://crowdin.com/profile/omersurer))
- GUI: Indonesian translation
  (thanks to @anggaariska, @isaideureka, and [Irham21](https://crowdin.com/profile/Irham21))
- GUI: Polish translation (thanks to @oschlypajac)
- GUI: Italian translation (thanks to @aitorres)


## Removed Features

- ``install.py`` helper script (use CMake or its front-ends directly)
- GUI: Crash handler (requires an external process; instead, rely on the OS default)


## Bug Fixes

- GUI: SIGSEGV on model modification with open report tree (#236)
- GUI: Zoom box is too reactive (#240)
- GUI: GateTable: Remove element is active w/o selected element (#241)


## Since v0.16.0

140 commits resulted in 290 files changed, 117096 insertions(+), 5798 deletions(-)

- Core: 95 files changed, 531 insertions(+), 582 deletions(-)
- Scripts: 5 files changed, 236 insertions(+), 139 deletions(-)
- GUI: 78 files changed, 6694 insertions(+), 3746 deletions(-)
- Tests: 42 files changed, 421 insertions(+), 659 deletions(-)
- Documentation: 5 files changed, 58 insertions(+), 20 deletions(-)
- Schemas: No change
